// --- Helper function that combines Fade.out and Buttons
// calling: bttnWithFadeOut({ bttn: workshopBttn });
// key bttn is the button that will get the abillity to cause fade.out
// and rest level
// it will return true if one button is pressed so the level shoudl have
// level.buttonActive = false but becomens true in this function on click
// other bttnWithFadeOut buttns in the level should be visible if (!level.buttonActive)
var bttnWithFadeOutClicked = false;
function bttnWithFadeOut(props) {
  var bttn = props.bttn ? props.bttn : false;

  if (bttn) {
    // if there is a button draw it
    bttn.draw(mouseOver);

    // bttn.click will return the oldVal or newVal (when clicked) 
    var bttnAction = bttn.click(mouse); 

    // if the current lvl should change according to bttns new value...
    if ( current != bttnAction) {
      bttnWithFadeOutClicked = bttnAction
    }

    // .. than begin fading out
    if (bttnWithFadeOutClicked) {
      fade.out();

      // when the fading process is done than change 
      // the current lvl, reset current lvl and reset this function
      if (fade.get("progress")==100) {
        resetMutableState(current);
        current = bttnWithFadeOutClicked;
        bttnWithFadeOutClicked = false;
        return true
      }
    }
  };
};

// this function will change old state to new for example
/* this will change level.progress from 25 to 26 after 4 seconds
    level.progress=timer({
      level: level, endAt: 4, nextVal: 26,  oldVal: 25
    });
level using it must have an endIt prop
*/
function timer(props) {
  var level = props.level;
  var endAt = props.endAt;
  var nextVal = props.nextVal;
  var oldVal = props.oldVal
  if (level.endIt==endAt) {
    // reset endIt and change the state
    level.endIt=0;
    return nextVal;
  } else {
    // increase level.endIt
    if (underSec == 0) { level.endIt++ }
    return oldVal;
  }
}

// turn sound on and off need a globally variable soundOn (boolean)
// and two buttons
function soundSwitch(m) {
  if (soundOn) {
    soundOn = soundBttnOff.click(mouseDown);
    soundBttnOff.draw(mouseOver);
  } else {
    soundOn = soundBttnOn.click(mouseDown);
    soundBttnOn.draw(mouseOver);
  }
}

// clickable logo with x,y,w,h coordinates
function clicker() {
  window.open("http://wetpussygames.com/", '_blank');
  return false
};

function linker(props) {
  var x = props.x+20;
  var y = props.y+20;
  var w = props.w ? props.w : 142*0.9;
  var h = props.h ? props.h : 157*0.9;

  if (mouseOver[0] <= x+w && mouseOver[1] <= y+h) {
    canvas.style.cursor="pointer"
  } else {
    canvas.style.cursor="default"
  }

  if ((x || x == 0) && (y || y==0)) {
    ctx.drawImage(img.wpg_logo, 0, 0, 142, 157, x, y, w, h);

    if (mouseDown[0] >= x && mouseDown[0] < w+x && mouseDown[1] >= y && mouseDown[1] < y+h) {
      canvas.style.cursor="pointer"
      canvas.addEventListener('click', clicker);
    } else {
      canvas.style.cursor="default"
      canvas.removeEventListener('click', clicker)
    }
  }
};

function bgMusic() {
  if (soundOn) { 
    snd.bg_music.play();
  } else {
    snd.bg_music.pause();
  }
}

var clickIcon = new Sprite({
  img: img.click_sprite, 
  sw: 125, sh: 175, dx: 500, dy: 500
});
function helpClick(dx, dy) {
  clickIcon.set({dx: dx, dy: dy});
  clickIcon.animate({num: 10});
  if (isIdle) {
    clickIcon.draw();
  }
};

var holdIcon = new Sprite({
  img: img.click_sprite, 
  sy: 175, sw: 125, sh: 175, dx: 500, dy: 500
});
function helpHold(dx, dy) {
  holdIcon.set({dx: dx, dy: dy});
  holdIcon.animate({num: 10});
  holdIcon.draw();
};

var lastSecond=0;
var isIdle=false;
function checkIfIdle() {
  if (mouseDown.length > 0) { lastSecond = levelSec };
  isIdle = lastSecond+4<levelSec ? true : false
};
